<template>
<div class="user-table">
  <table class="table table-bordered">
  <thead class="thead-dark">
    <tr> 
      <th>No</th>
      <th>Nama Depan</th>
      <th>Nama Belakang</th>
      <th>Edit</th>
      <th>Hapus</th>
    </tr>
  </thead>
  <tbody> 
      <tr v-for="user in users" :key="user.id">
    <template v-if="customerId === user.id">
      <td>
        <label for="name" class="font-weight-bold">Nama:</label>
        <div> 
          <input type="text" v-model="user.name" class="form-control" />
        </div>
      </td>
      <td>
        <label for="email" class="font-weight-bold">Email:</label>
        <div> 
          <input type="text" v-model="user.email" class="form-control" />
        </div>
      </td>
      <td>
        <label for="address" class="font-weight-bold">Address:</label>
        <div> 
          <input type="text" v-model="user.address" class="form-control"  />
        </div>
      </td>
      <td> 
        <div class="mt-4">
        <button class="btn btn-success m-2" @click="saveEdit(user)">Save</button>
        <button class="btn btn-danger" @click="cancelEdit(user)" >Cancel</button>
        </div>
      </td>
    </template>
    <template v-else>
      <tr v-for="(user, index) in allData" :key="index">
        <td>{{ index+1 }}</td>
        <td>{{user.name}}</td>
        <td>{{user.email}}</td>
        <td>{{user.address}}</td>
        <td>
          <div class="text-center">
          <button class="btn btn-primary mr-2" @click="editCustomer(user)">Edit</button>
          </div>
        </td>
        <td>
          <div class="text-center">
          <button class="btn btn-danger" @click="deleteCustomer(user.id)">Hapus</button> 
          </div>
        </td>
      </tr>
    </template>
  </tr>
  </tbody>
</table>
</div>
</template>
<script>
 
  export default {
    name: 'user-tabel', 
    props: {
      users: Array,
    },
    data() {
      return {
          userId: null,
        }
      },
      methods: {
        editCustomer(user) { 
          this.data = Object.assign({}, user)
          this.userId = user.id 
          // console.log(this.data);
        },
        saveEdit(user) { 
          let id = this.data.id
          this.$emit('edit-customer', id, user)  
          this.userId = null
        },
        cancelEdit(user) { 
          Object.assign(user, this.data)
          this.userId = null;
          // console.log(this.customerId);
        },
        deleteCustomer(id){
          this.$emit('delete-customer', id)  
        }
      }
  }
</script>

<style scoped> 
</style>